function love.load()
rect1 = Rect.new(1, 120, 180, {255,255,255})
rect2 = Rect.new(2, 200, 300, {255,255,0})
end

Rect = {list = {}}
function Rect.new(id,x,y, color)
	local r = {}
	r.x = x
	r.y = y
	r.width = 100
	r.height = 100
	r.dragging = { active = false, diffX = 0, diffY = 0 }
	r.color = color
	function r:draw()
		love.graphics.setColor(self.color)
		love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
	end
	Rect.list[id] = r
	return r
end

function love.draw()
	for i,v in pairs(Rect.list) do
		v:draw()
	end
end

function love.mousepressed(x, y, button)
	if button == "l" then
		for i,v in pairs(Rect.list) do
			if x > v.x and x < v.x + v.width
			and y > v.y and y < v.y + v.height
			then
			v.dragging.active = true
			v.dragging.diffX = x - v.x
			v.dragging.diffY = y - v.y
			end
		end
	end
end

function love.update(dt)
	for i, v in pairs(Rect.list) do
		if v.dragging.active then
			v.x = love.mouse.getX() - v.dragging.diffX
			v.y = love.mouse.getY() - v.dragging.diffY
		end
	end
end

function love.mousereleased(x, y, button)
	if button == "l" then 
		for i,v in pairs(Rect.list) do
			v.dragging.active = false 
		end
  	end
end